using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.DirectX;
using Microsoft.DirectX.DirectSound;

namespace MDXLibrary.DXSound
{
    /// <summary>
    /// ʉĐ̕@B
    /// </summary>
    public enum MDXSoundEffectPlayMode { 
        /// <summary>ĐɍēxĐvĂȂɂ܂B</summary>
        Single,

        /// <summary>ĐɍēxĐvꍇAĐ~čēx擪Đ܂B</summary>
        SingleRestart,
        
        /// <summary>ĐɍēxĐvꍇAdĐ܂B</summary>
        Multi,
        
        /// <summary>ĐIƁA擪ēxĐ܂BĐɍēxĐvĂȂɂ܂B</summary>
        Loop
    };


    /// <summary>
    /// ʉĐ邽߂̃NXB
    /// MDXSoundNXŗpB
    /// </summary>
    public class MDXSoundEffect:IDisposable
    {
        /// <summary>
        /// ʉt@Čʐݒۑ邽߂̃NX
        /// </summary>
        public class EffectSetting {
            public int   Volume;
            public int   Pan;
            public float Frequency;

            public EffectSetting() {
                this.SetDefault();
            }

            public void SetDefault() {
                this.Volume    = 0;
                this.Pan       = 0;
                this.Frequency = 1f;
            }

            public void Save(string sFileName) {
                System.IO.FileStream fs = new System.IO.FileStream(sFileName, System.IO.FileMode.Create);
                new System.Xml.Serialization.XmlSerializer(this.GetType()).Serialize(fs, this);
                fs.Close();
            }

            public void Load(string sFileName) {
                System.IO.FileStream fs = new System.IO.FileStream(sFileName, System.IO.FileMode.Open);
                EffectSetting sTmp = (EffectSetting)new System.Xml.Serialization.XmlSerializer(this.GetType()).Deserialize(fs);
                fs.Close();

                this.Volume    = sTmp.Volume;
                this.Pan       = sTmp.Pan;
                this.Frequency = sTmp.Frequency;
            }
        }

        public  SecondaryBuffer        Buffer;
        public  List<SecondaryBuffer>  SubBuffers;
        public  MDXSoundEffectPlayMode PlayMode;
        public  int                    DefaultFrequency;
        private int                    MultiMax;
        private MDXSound               MDXSound;
        private EffectSetting          EffectSettings;

        /// <summary>
        /// RXgN^B
        /// </summary>
        /// <param name="mdxSound"    >eB</param>
        /// <param name="sWavFileName">ǂݍމt@CBwav̂݁BK\ΉB</param>
        /// <param name="iMultiMax"   >dĐ̍ő吔B</param>
        /// <param name="mdxPlayMode" >ʉĐ̕@B</param>
        public MDXSoundEffect(MDXSound mdxSound, string sWavFileName, int iMultiMax, MDXSoundEffectPlayMode mdxPlayMode)
        {
            //t@C𐳋K\Ή
            string sTrueFileName = "";
            if (System.IO.File.Exists(sWavFileName)) {
                sTrueFileName = sWavFileName;
            } else {
                foreach (string s in System.IO.Directory.GetFiles(System.IO.Path.GetDirectoryName(sWavFileName))) {
                    if (System.Text.RegularExpressions.Regex.Match(System.IO.Path.GetFileName(s), "^" + System.IO.Path.GetFileName(sWavFileName), System.Text.RegularExpressions.RegexOptions.IgnoreCase).Value != "") {
                        sTrueFileName = s;
                        break;
                    }
                }
            }

            if (sTrueFileName != "") {
                BufferDescription bd = new BufferDescription();
                bd.ControlFrequency = true;
                bd.ControlPan       = true;
                bd.ControlVolume    = true;
                this.Buffer   = new SecondaryBuffer(sTrueFileName, bd, mdxSound.Device);
                this.MDXSound = mdxSound;
                this.PlayMode = mdxPlayMode;
                this.MultiMax = iMultiMax;
                this.DefaultFrequency = this.Buffer.Frequency;
                if (this.PlayMode == MDXSoundEffectPlayMode.Multi) {
                    this.SubBuffers = new List<SecondaryBuffer>();
                }

                //ݒt@CΓǂݍ
                this.EffectSettings = new EffectSetting();
                if (System.IO.File.Exists(sTrueFileName + ".EffectSetting")) {
                    this.EffectSettings.Load(sTrueFileName + ".EffectSetting");
                } else {
                    this.EffectSettings.SetDefault();
                    this.EffectSettings.Save(sTrueFileName + ".EffectSetting");
                }
            }
        }

        /// <summary>
        /// ʉĐB
        /// </summary>
        /// <param name="iVolume"   >ʁB</param>
        /// <param name="iPan"      >E̕΂B</param>
        /// <param name="fFrequency">gBi1:̂܂܁A0.5:̑xA2:{̑xB</param>
        public void Play(int iVolume, int iPan, float fFrequency)
        {
            if (this.Buffer != null) {
                if (!this.Buffer.Status.Playing) {
                    this.Buffer.Volume    = iVolume + this.EffectSettings.Volume;
                    this.Buffer.Pan       = iPan    + this.EffectSettings.Pan;
                    this.Buffer.Frequency = (int)((float)this.DefaultFrequency * fFrequency * this.EffectSettings.Frequency);
                    if (this.PlayMode == MDXSoundEffectPlayMode.Loop) {
                        this.Buffer.Play(0, BufferPlayFlags.Looping);
                    } else {
                        this.Buffer.Play(0, BufferPlayFlags.Default);
                    }
                } else {
                    switch (this.PlayMode) {
                        case MDXSoundEffectPlayMode.Loop:
                            //Ȃ
                            break;

                        case MDXSoundEffectPlayMode.Single:
                            //Ȃ
                            break;

                        case MDXSoundEffectPlayMode.SingleRestart:
                            //~ēĐ
                            this.Buffer.Stop();
                            this.Buffer.SetCurrentPosition(0);
                            this.Buffer.Volume    = iVolume + this.EffectSettings.Volume;
                            this.Buffer.Pan       = iPan    + this.EffectSettings.Pan;
                            this.Buffer.Frequency = (int)((float)this.DefaultFrequency * fFrequency * this.EffectSettings.Frequency);
                            this.Buffer.Play(0, BufferPlayFlags.Default);
                            break;

                        case MDXSoundEffectPlayMode.Multi:
                            //SubBuffersɒ~Ԃ̂΂ĐEȂΐVǉčĐ
                            bool bAddFlag = true;
                            foreach (SecondaryBuffer sb in this.SubBuffers) {
                                if (!sb.Status.Playing) {
                                    sb.Volume    = iVolume + this.EffectSettings.Volume;
                                    sb.Pan       = iPan    + this.EffectSettings.Pan;
                                    sb.Frequency = (int)((float)this.DefaultFrequency * fFrequency * this.EffectSettings.Frequency);
                                    sb.Play(0, BufferPlayFlags.Default);
                                    bAddFlag = false;
                                    break;
                                }
                            }
                            if (bAddFlag && this.SubBuffers.Count < this.MultiMax) {
                                SecondaryBuffer sb = this.Buffer.Clone(this.MDXSound.Device);
                                this.SubBuffers.Add(sb);
                                sb.Volume    = iVolume + this.EffectSettings.Volume;
                                sb.Pan       = iPan    + this.EffectSettings.Pan;
                                sb.Frequency = (int)((float)this.DefaultFrequency * fFrequency * this.EffectSettings.Frequency);
                                sb.Play(0, BufferPlayFlags.Default);
                            }
                            break;
                    }
                }
            }
        }

        /// <summary>
        /// ʉ~B
        /// </summary>
        public void Stop()
        {
            if (this.Buffer != null) {
                if (this.PlayMode != MDXSoundEffectPlayMode.Multi) {
                    this.Buffer.Stop();
                }
            }
        }

        /// <summary>
        /// ʉĐ̕@MultȉꍇɁAdĐpɊmۂꂽSecondaryBufferJB
        /// </summary>
        public void SubBuffersDispose()
        {
            if (this.SubBuffers != null)
            {
                foreach (SecondaryBuffer sb in this.SubBuffers)
                {
                    if (sb != null)
                    {
                        sb.Dispose();
                    }
                }
                this.SubBuffers.Clear();
            }
        }

        /// <summary>
        /// \[XJB
        /// </summary>
        public void Dispose()
        {
            this.SubBuffersDispose();
            this.SubBuffers = null;

            if (this.Buffer != null)
            {
                this.Buffer.Dispose();
                this.Buffer = null;
            }
        }

        void IDisposable.Dispose()
        {
            this.Dispose();
        }
    }
}
