using System;
using System.Collections.Generic;
using System.Text;

using MDXLibrary.DXGraphics;
using MDXLibrary.DXSound;

namespace Shibuya.Enemys {
    public class EnemyA : Enemy {
        const int PADEFFECTFRAME    = 15;
        const int CLASHEDCLEARCOUNT = 30;

        #region IuWFNgiÓIj

        static MDXTexture     Texture;  //G̉摜
        static MDXSoundEffect SE;       //Փˎʉ

        #endregion


        #region IuWFNgiJj

        public float  Speed;
        public double Angle;
        public int    BackColor;
        public int    UpdateCount;
        public int    ClashedClearCount;

        #endregion


        #region ֐iÓIj

        public static void Initialize() {
            Texture = Pub.Graphics.GetTexture(@"Image\EnemyA.*");
            SE = Pub.Sound.GetSoundEffect(@"Sound\Clash.*", 5, MDXSoundEffectPlayMode.Multi);
        }

        public static void Dispose() {
            if (Texture != null) {
                Texture.Dispose();
                Texture = null;
            }

            if (SE != null) {
                SE.Dispose();
                SE = null;
            }
        }

        #endregion


        #region ֐iEJȂǁj

        public EnemyA() {
            this.Init();
        }

        #endregion


        #region ֐iXVE`j

        public override void Update() {
            this.UpdateCount++;
            this.X += (float)(Math.Cos(this.Angle) * this.Speed);
            this.Y += (float)(Math.Sin(this.Angle) * this.Speed);
            if (this.BackColor % 2 == 0) this.Angle += 0.0075;
            else                         this.Angle -= 0.0075;
            if (this.X < -10 || this.X > Pub.WindowWidth + 10 ||
                this.Y < -10 || this.Y > Pub.WindowHeight + 10) {
                this.Zombie = true;
            }
            float fSizeP = (float)(Math.Sin(this.UpdateCount / 32.1) * 0.01);
            this.Scale += fSizeP;
            this.Speed += fSizeP * 5;
            if (this.Clashed) {
                if (this.ClashedClearCount == CLASHEDCLEARCOUNT) {
                    //Փ˒ɌʉȂ炵ăpbhU
                    EnemyA.SE.Play(0, (int)(((float)this.X / (float)Pub.WindowWidth - 0.5f) * 5000f), 3f - this.Scale);
                    if (Pub.PadEffectFrame < PADEFFECTFRAME) Pub.PadEffectFrame = PADEFFECTFRAME;
                }
                if (this.ClashedClearCount <= 0) {
                    Pub.Crash++;
                    this.Zombie = true;
                } else {
                    int iAlpha = (int)(((uint)this.BackColor >> 24) * 0.9f);
                    this.BackColor = ((0x00ffffff ^ this.BackColor) & 0x00ffffff) | (iAlpha << 24);
                }
                this.ClashedClearCount--;
            } else {
                int iAlpha = (int)(Math.Sin(this.UpdateCount / 65.4) * 100.0) + 155;
                this.BackColor = (this.BackColor & 0x00ffffff) | (iAlpha << 24);
            }
        }

        public override void Draw() {
            Pub.Graphics.SpriteDraw((int)this.X, (int)this.Y, 0.5f, 0.5f, Scale, (float)(Angle + Math.PI / 2.0), this.BackColor, Texture);
        }

        #endregion


        #region ֐ȋFJj

        //ԂԂɂ
        private void Init() {
            //ʒuʂ̒[ɂȂ悤ɂ
            if (Pub.Rnd.Next() % 2 == 0) {
                if (Pub.Rnd.Next() % 2 == 0) {
                    this.X = Pub.WindowWidth + 10f;
                    this.Y = (float)(Pub.Rnd.Next() % Pub.WindowHeight);
                    this.Angle = Pub.Rnd.NextDouble() * Math.PI + Math.PI / 2;
                } else {
                    this.X = -10f;
                    this.Y = (float)(Pub.Rnd.Next() % Pub.WindowHeight);
                    this.Angle = Pub.Rnd.NextDouble() * Math.PI + Math.PI + Math.PI / 2;
                }
            } else {
                if (Pub.Rnd.Next() % 2 == 0) {
                    this.X = (float)(Pub.Rnd.Next() % Pub.WindowWidth);
                    this.Y = Pub.WindowHeight + 10;
                    this.Angle = Pub.Rnd.NextDouble() * Math.PI + Math.PI;
                } else {
                    this.X = (float)(Pub.Rnd.Next() % Pub.WindowWidth);
                    this.Y = -10;
                    this.Angle = Pub.Rnd.NextDouble() * Math.PI;
                }
            }
            //this.Angle             = Pub.Rnd.NextDouble() * Math.PI * 2.0;
            this.Scale             = (float)(Pub.Rnd.NextDouble() * 1.5 + 0.5);
            this.Speed             = (float)(Pub.Rnd.NextDouble() * 2.5 + 0.5);
            this.BackColor         = Pub.Rnd.Next();
            this.Radius            = EnemyA.Texture.Width;
            this.UpdateCount       = 0;
            this.Clashed           = false;
            this.ClashedClearCount = CLASHEDCLEARCOUNT;
            this.Offense           = 10;
            this.Zombie            = false;
        }

        #endregion
    }
}
