using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.DirectX.DirectSound;
using Microsoft.DirectX.DirectInput;

using MDXLibrary.DXGraphics;
using MDXLibrary.DXSound;
using MDXLibrary.DXInput;

using Shibuya.Players;
using Shibuya.Enemys;
using Shibuya.Settings;

namespace Shibuya 
{
    public partial class GameForm : MDXLibrary.Game.MDXGameForm 
    {
        #region 萔

        const int    ENEMYMIN       = 10;   //ŏ̓G̕C
        const int    ENEMYMAX       = 1000; //G̍őC
        const int    NEXTENEMYCOUNT = 180;  //GPC܂ł̃t[

        #endregion


        #region IuWFNg(j
        #endregion


        #region IuWFNgij

        MDXFont TitleFont;
        MDXFont ScoreFont;
        bool    PadEffectStarted = false;
        bool    bDemo            = true;
        int     iDemoAddWait     = 0;
        int     iNextEnemyCount  = NEXTENEMYCOUNT;
        int     iClearColor;
        int     iClearR, iClearG, iClearB;

        #endregion


        #region ֐iRXgN^Ȃǁj

        public GameForm() {
            InitializeComponent();
        }

        #endregion


        #region ֐(Q[[v֘Aj

        protected override void FuncGameLoopStarting() {
            //Q[[vݒ
            this.FuncTickEnable = true;
            //this.WaitOffMode = true;

            //iSQƏj
            Pub.Initialize(this, 1024, 768);

            //iGj
            EnemyA.Initialize();
            EnemyB.Initialize();
            EnemyC.Initialize();
            for (int i = 0; i < ENEMYMIN; i++) {
                this.AddEnemy();
            }

            //tHgݒ
            this.TitleFont = Pub.Graphics.GetFont("Impact", 128);
            this.ScoreFont = Pub.Graphics.GetFont("lr SVbN", 32);

            //^CgyJn
            Pub.Sound.MusicStart(@"Music\Title.*", true);
        }

        protected override void FuncGameLoopEnding() {
            //JiGj
            EnemyA.Dispose();
            EnemyB.Dispose();
            EnemyC.Dispose();

            //JiSj
            Pub.Dispose();
        }

        protected override void FuncFrameUpdate() {
            if (bDemo) {
                DemoUpdate();
            } else {
                GameUpdate();
            }
        }

        protected override void FuncFrameDraw() {
            if (bDemo) {
                DemoDraw();
            } else {
                GameDraw();
            }
        }

        protected override void FuncTick() {
            //FPS\
            //this.Text = "FPS:" + FPS + " SKIP:" + SkipFrameCount + " LOST:" + LostFrameCount;
        }

        #endregion


        #region ֐ieTu[`j

        private void DemoUpdate() {
            //`t[
            Pub.FrameTotal++;

            //L[͏ԍXVE擾iVXenj
            {
                Pub.Input.VirtualUpdate();

                //I
                if (Pub.InputButtons[(int)VKeys.End] > 100) {
                    this.GameLoopEndFlag = true;
                }

                //EChETCYύX
                if (Pub.InputButtons[(int)VKeys.Window] > 100) {
                    Pub.Windowed = !Pub.Windowed;
                    Pub.Graphics.ChangeWindowMode(Pub.Windowed);
                }

                //{^ݒύX
                if (Pub.InputButtons[(int)VKeys.Setting] > 100) {
                    if (!Pub.Windowed) Pub.Graphics.ChangeWindowMode(true);
                    MDXInputVirtualSettingForm f = new MDXInputVirtualSettingForm(Pub.Input);
                    f.ShowDialog();
                    if (!Pub.Windowed) Pub.Graphics.ChangeWindowMode(false);
                }

                //Wait[hύX
                if (Pub.InputButtons[(int)VKeys.Wait] > 100) {
                    while (Pub.InputButtons[(int)VKeys.Wait] > 100) Pub.Input.VirtualUpdate();
                    this.WaitOffMode = !this.WaitOffMode;
                }

                //Q[Jn
                MouseState ms = Pub.Input.MouseGetState();
                if (Pub.InputButtons[(int)VKeys.Start] > 100 || ms.GetMouseButtons()[0] > 100) {
                    this.bDemo = false;

                    Pub.Player.Reset();

                    Pub.Enemys.Clear();
                    for (int i = 0; i < ENEMYMIN; i++) {
                        this.AddEnemy();
                    }

                    Pub.Input.MouseGetState();
                    Pub.Input.JoystickGetState(0);

                    Pub.Sound.MusicStart(@"Music\Game.*", true);
                }
            }

            //XViGj
            foreach (Enemy e in Pub.Enemys) {
                e.Update();
            }

            //ZombieԂ̓G̏
            for (int i = 0; i < Pub.Enemys.Count; i++) {
                if (Pub.Enemys[i].Zombie) {
                    if (this.FPS >= 60 && this.iDemoAddWait == 0) {
                        Pub.Enemys.RemoveAt(i);
                        this.AddEnemy();
                    } else {
                        Pub.Enemys.RemoveAt(i);
                    }
                }
            }

            //G
            if (this.FPS >= 60) {
                if (this.iDemoAddWait == 0) {
                    this.AddEnemy();
                    this.AddEnemy();
                } else {
                    this.iDemoAddWait--;
                }
                if (Pub.Enemys.Count > 1) {
                    Pub.Enemys[0].Clashed = true;
                    Pub.Enemys[1].Clashed = true;
                }
            } else {
                if (this.FPS >= 55) {
                    if (Pub.Enemys.Count > 4) {
                        Pub.Enemys[0].Clashed = true;
                        Pub.Enemys[1].Clashed = true;
                        Pub.Enemys[2].Clashed = true;
                        Pub.Enemys[3].Clashed = true;
                        Pub.Enemys[4].Clashed = true;
                    }
                } else {
                    this.iDemoAddWait += 2;
                    if (Pub.Enemys.Count > 8) {
                        Pub.Enemys[0].Clashed = true;
                        Pub.Enemys[1].Clashed = true;
                        Pub.Enemys[2].Clashed = true;
                        Pub.Enemys[3].Clashed = true;
                        Pub.Enemys[4].Clashed = true;
                        Pub.Enemys[5].Clashed = true;
                        Pub.Enemys[6].Clashed = true;
                        Pub.Enemys[7].Clashed = true;
                        Pub.Enemys[8].Clashed = true;
                    }
                }
            }

            //XS
            if (Pub.Rnd.Next(1000) == 1) {
                foreach (Enemy e in Pub.Enemys) {
                    if (Pub.Rnd.Next(4) == 0) {
                        e.Clashed = true;
                    }
                }
            }
            if (Pub.Rnd.Next(3000) == 1) {
                foreach (Enemy e in Pub.Enemys) {
                    if (Pub.Rnd.Next(2) == 0) {
                        e.Clashed = true;
                    }
                }
            }
            if (Pub.Rnd.Next(6000) == 1) {
                foreach (Enemy e in Pub.Enemys) {
                    e.Clashed = true;
                }
            }
            if (Pub.Enemys.Count <= 0) this.iDemoAddWait = 0;
        }

        private void DemoDraw() {
            Pub.Graphics.Clear(unchecked((int)0xffffffff));

            //`Jn
            Pub.Graphics.BeginScene();
            Pub.Graphics.SpriteBegin(SpriteFlags.AlphaBlend);

            //`揈iGj
            foreach (Enemy e in Pub.Enemys) {
                e.Draw();
            }

            //`i^Cgj
            string sTitle    = "SHIBUYA WARS";
            string sSubTitle = "Dodge The Attack";
            Pub.Graphics.SpriteTextDraw(Pub.WindowWidth / 2, Pub.WindowHeight / 2 - 50, sTitle.Length * 26, 64, 1f, 0f, unchecked((int)0x80ffff00), MDXDrawMode.Normal, sTitle, TitleFont);
            Pub.Graphics.SpriteTextDraw(Pub.WindowWidth / 2, Pub.WindowHeight / 2 + 20, sSubTitle.Length * 23, 64, 0.35f, 0f, unchecked((int)0x80ffff00), MDXDrawMode.Normal, sSubTitle, TitleFont);

            //`iRs[Cgj
            string sCopyright = "2006 - Fight Not Found";
            Pub.Graphics.SpriteTextDraw(Pub.WindowWidth / 2, Pub.WindowHeight / 2 + 80, sCopyright.Length * 22, 64, 0.25f, 0f, unchecked((int)0xb4ffffff), MDXDrawMode.Normal, sCopyright, TitleFont);

            //`ij
            Pub.Graphics.SpriteTextDraw(10, 10, unchecked((int)0x80000000), "FPS:" + FPS + " SKIP:" + SkipFrameCount + " LOST:" + LostFrameCount + " AddWait:" + this.iDemoAddWait + " EnemyCount:" + Pub.Enemys.Count);
            Pub.Graphics.SpriteTextDraw(10, Pub.WindowHeight - 110, unchecked((int)0x80ff80ff),
                "Start          : " + Pub.Input.VirtualDefine.Keyboard[0][(int)VKeys.Start].ToString() + "\n" +
                "End            : " + Pub.Input.VirtualDefine.Keyboard[0][(int)VKeys.End].ToString() + "\n" +
                "Full Screene   : " + Pub.Input.VirtualDefine.Keyboard[0][(int)VKeys.Window].ToString() + "\n" +
                "Button Setting : " + Pub.Input.VirtualDefine.Keyboard[0][(int)VKeys.Setting].ToString() + "\n"
            );

            //`i_j
            Pub.Graphics.SpriteTextDraw(Pub.WindowWidth - 230, 70, unchecked((int)0x80000000), "TOP:" + Pub.GameSetting.TopScore.ToString("0000000"), ScoreFont);
            if (Pub.Player.TotalFrame > 0) {
                Pub.Graphics.SpriteTextDraw(Pub.WindowWidth - 230, 100, unchecked((int)0x80000000), "YOU:" + Pub.Player.TotalFrame.ToString("0000000"), ScoreFont);
            }

            //`I
            Pub.Graphics.SpriteEnd();
            Pub.Graphics.EndScene();
            Pub.Graphics.Present();
        }

        private void GameUpdate() {
            //`t[
            Pub.FrameTotal++;

            //L[͏ԍXVE擾iVXenj
            {
                Pub.Input.VirtualUpdate();

                //I
                if (Pub.InputButtons[(int)VKeys.End] > 100) {
                    while (Pub.InputButtons[(int)VKeys.End] > 100) Pub.Input.VirtualUpdate();
                    Pub.Player.HP = 0;
                }

                //EChETCYύX
                if (Pub.InputButtons[(int)VKeys.Window] > 100) {
                    Pub.Windowed = !Pub.Windowed;
                    Pub.Graphics.ChangeWindowMode(Pub.Windowed);
                }

                //{^ݒύX
                if (Pub.InputButtons[(int)VKeys.Setting] > 100) {
                    if (!Pub.Windowed) Pub.Graphics.ChangeWindowMode(true);
                    MDXInputVirtualSettingForm f = new MDXInputVirtualSettingForm(Pub.Input);
                    f.ShowDialog();
                    if (!Pub.Windowed) Pub.Graphics.ChangeWindowMode(false);
                }

                //G
                if (Pub.InputButtons[(int)VKeys.AddEnemy] > 100) {
                    if (Pub.Enemys.Count < ENEMYMAX) {
                        this.AddEnemy();
                    }
                }

                //Wait[hύX
                if (Pub.InputButtons[(int)VKeys.Wait] > 100) {
                    while (Pub.InputButtons[(int)VKeys.Wait] > 100) Pub.Input.VirtualUpdate();
                    this.WaitOffMode = !this.WaitOffMode;
                }
            }

            //蔻菈i@̓Gj
            this.ClashCheck();

            //XVi@j
            Pub.Player.Update();

            //XViGj
            foreach (Enemy e in Pub.Enemys) {
                e.Update();
            }

            //ZombieԂ̓G̏
            for (int i = 0; i < Pub.Enemys.Count; i++) {
                if (Pub.Enemys[i].Zombie) {
                    Pub.Enemys.RemoveAt(i);
                    this.AddEnemy();
                    //Pub.Enemys[i] = new EnemyA();
                }
            }

            //@HP0ɂȂ̏
            if (Pub.Player.HP <= 0) {
                if (Pub.Player.TotalFrame > Pub.GameSetting.TopScore) {
                    Pub.GameSetting.TopScore = Pub.Player.TotalFrame;
                }
                Pub.Sound.MusicStart(@"Music\Title.*", true);
                bDemo = true;
            }

            //G
            this.iNextEnemyCount--;
            if (this.iNextEnemyCount == 0) {
                this.iNextEnemyCount = NEXTENEMYCOUNT; //XXt[ɓGĂ
                if (Pub.Enemys.Count < ENEMYMAX) {
                    this.AddEnemy();
                }
            }

            //U̐
            if (this.PadEffectStarted) {
                if (Pub.PadEffectFrame == 0) {
                    Pub.Input.JoystickEffectStop(0);
                    Pub.Input.JoystickEffectSetGain(0, 0);
                    this.PadEffectStarted = false;
                } else {
                    Pub.PadEffectFrame--;
                }
            } else {
                if (Pub.PadEffectFrame > 0) {
                    Pub.Input.JoystickEffectStart(0);
                    Pub.Input.JoystickEffectSetGain(0, 10000);
                    this.PadEffectStarted = true;
                }
            }
        }

        private void GameDraw() {
            //ʃNA
            iClearR = (int)(Math.Sin(Pub.FrameTotal / 65.4) * 127.0) + 128;
            iClearG = (int)(Math.Sin(Pub.FrameTotal / 43.2) * 127.0) + 128;
            iClearB = (int)(Math.Sin(Pub.FrameTotal / 23.4) * 127.0) + 128;
            iClearColor = (0xff << 24) | (iClearR << 16) | (iClearG << 8) | (iClearB);
            Pub.Graphics.Clear(iClearColor);

            //`Jn
            Pub.Graphics.BeginScene();
            Pub.Graphics.SpriteBegin(SpriteFlags.AlphaBlend);

            //`揈iGj
            foreach (Enemy e in Pub.Enemys) {
                e.Draw();
            }

            //`揈i@j
            Pub.Player.Draw();

            //`ij
            Pub.Graphics.SpriteTextDraw(10, 10, iClearColor ^ 0x00ffffff, "FPS:" + FPS + " SKIP:" + SkipFrameCount + " LOST:" + LostFrameCount + " EnemyCount:" + Pub.Enemys.Count + " HP:" + Pub.Player.HP);

            //`i_j
            Pub.Graphics.SpriteTextDraw(Pub.WindowWidth - 230, 70, iClearColor ^ 0x00ffffff, "TOP:" + Pub.GameSetting.TopScore.ToString("0000000"), ScoreFont);
            Pub.Graphics.SpriteTextDraw(Pub.WindowWidth - 230, 100, iClearColor ^ 0x00ffffff, "YOU:" + Pub.Player.TotalFrame.ToString("0000000"), ScoreFont);

            //`I
            Pub.Graphics.SpriteEnd();
            Pub.Graphics.EndScene();
            Pub.Graphics.Present();
        }

        private void AddEnemy() {
            switch (Pub.Rnd.Next(3)) {
                case 0:
                    Pub.Enemys.Add(new EnemyA());
                    break;

                case 1:
                    Pub.Enemys.Add(new EnemyB());
                    break;

                case 2:
                    Pub.Enemys.Add(new EnemyC());
                    break;
            }
        }

        #endregion


        #region ֐iՓ˔j

        private void ClashCheck() {
            float fRadiusPlayer = Pub.Player.Radius * Pub.Player.Scale;
            foreach (Enemy e in Pub.Enemys) {
                float fRadiusEnemy = e.Radius * e.Scale;
                float fRadiusSum   = fRadiusPlayer + fRadiusPlayer;
                float fXDec        = Pub.Player.X - e.X;
                float fYDec        = Pub.Player.Y - e.Y;
                float fDistance    = fXDec * fXDec + fYDec * fYDec;
                if (fDistance * Pub.GameSetting.ClashCheckLevel < fRadiusSum * fRadiusSum) { //傫Ɠ蔻肪Ȃ
                    e.Clashed = true;
                    if (!Pub.Player.Clashed) {
                        Pub.Player.Clashed = true;
                        Pub.Player.HP -= e.Offense;
                    }
                }
            }
        }

        #endregion


        #region ֐iCxgj

        //EBhETCYύX
        private void Game_Tamayoke_SizeChanged(object sender, EventArgs e) {
            Pub.WindowHeight = this.Height;
            Pub.WindowWidth  = this.Width;
        }

        #endregion
    }
}

