using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

using MDXLibrary.DXGraphics;
using MDXLibrary.DXSound;
using MDXLibrary.DXInput;

using Shibuya.Players;
using Shibuya.Enemys;
using Shibuya.Settings;

namespace Shibuya
{
    /// <summary>
    /// {^`
    /// </summary>
    public enum VKeys { Up, Down, Left, Right, End, Start, Window, Setting, Wait, AddEnemy };

    /// <summary>
    /// ŜQƂ
    /// </summary>
    public class Pub
    {
        public static string GaneName = "SHIBUYA";

        public static Control     Control;          //e
        public static MDXGraphics Graphics;         //`pfoCX
        public static MDXSound    Sound;            //pfoCX
        public static MDXInput    Input;            //͗pfoCX
        public static byte[]      InputButtons;     //zfoCX{^
        public static Random      Rnd;              //
        public static int         WindowWidth;      //ʂ̉
        public static int         WindowHeight;     //ʂ̍
        public static long        FrameTotal;       //`t[
        public static bool        Windowed;         //EChE[h

        public static int         Crash;            //Փ˂
        public static int         PadEffectFrame;   //pbhU̎ct[

        public static List<Enemy> Enemys;
        public static Player      Player;

        public static Setting     GameSetting;

        public static void Initialize(Control cControl, int iWindowWidth, int iWindowHeight)
        {
            Pub.Control          = cControl;
            Pub.WindowWidth      = iWindowWidth;
            Pub.WindowHeight     = iWindowHeight;
            Pub.Windowed         = true;
            Pub.Graphics         = new MDXGraphics(Pub.Control, Pub.WindowWidth, Pub.WindowHeight, 60, Pub.Windowed);
            Pub.Sound            = new MDXSound(Pub.Control);
            Pub.Rnd              = new Random();
            Pub.FrameTotal       = 0;
            Pub.Crash            = 0;
            Pub.PadEffectFrame   = 0;
            Pub.Player           = new Player();
            Pub.Enemys           = new List<Enemy>();
            Pub.GameSetting      = new Setting(GaneName + ".Setting");

            //L[͊֘A
            Pub.Input = new MDXInput(Pub.Control);
            //Pub.Input = new MDXInput(Pub.Control, CooperativeLevelFlags.NonExclusive | CooperativeLevelFlags.Background);
            if (System.IO.File.Exists(Pub.GaneName + ".ButtonDefine"))
            {
                Pub.Input.VirtualDefineSettingLoad(Pub.GaneName + ".ButtonDefine");
            }
            else
            {
                String[] sDescript = new String[10];
                sDescript[(int)VKeys.Up]       = "";
                sDescript[(int)VKeys.Down]     = "";
                sDescript[(int)VKeys.Left]     = "";
                sDescript[(int)VKeys.Right]    = "";
                sDescript[(int)VKeys.Start]    = "Q[Jn";
                sDescript[(int)VKeys.End]      = "Q[I";
                sDescript[(int)VKeys.Setting]  = "{^ݒ";
                sDescript[(int)VKeys.Window]   = "tXN[ؑ";
                sDescript[(int)VKeys.Wait]     = "EFCgύX";
                sDescript[(int)VKeys.AddEnemy] = "GႤ";
                Pub.Input.VirtualDeviceDefine(1, 10, sDescript);
                MDXInputVirtualSettingForm f = new MDXInputVirtualSettingForm(Pub.Input);
                f.ShowDialog();
            }
            Pub.InputButtons = Pub.Input.VirtualGetButtons(0);
        }

        public static void Dispose()
        {
            if (Pub.Graphics != null)
            {
                Pub.Graphics.Dispose();
                Pub.Graphics = null;
            }

            if (Pub.Input != null)
            {
                Pub.Input.VirtualDefineSettingSave(Pub.GaneName + ".ButtonDefine");
                Pub.Input.Dispose();
                Pub.Input = null;
            }

            if (Pub.Player != null)
            {
                Pub.Player.Dispose();
                Pub.Player = null;
            }

            if (Pub.GameSetting != null)
            {
                Pub.GameSetting.Save(GaneName + ".Setting");
                Pub.GameSetting = null;
            }
        }
    }
}
